// Copyright (c) Shinichi Yamagiwa, 2007
// ARmGDBX^u _E[hTvvO

//#define IRQ_TEST
#define SWI_TEST

#define MMR_BASE 0xFFFF0000

#define GP0CON *((volatile unsigned int *)(MMR_BASE + 0xF400))
#define GP1CON *((volatile unsigned int *)(MMR_BASE + 0xF404))
#define GP2CON *((volatile unsigned int *)(MMR_BASE + 0xF408))
#define GP3CON *((volatile unsigned int *)(MMR_BASE + 0xF40C))
#define GP4CON *((volatile unsigned int *)(MMR_BASE + 0xF410))
#define GP4DAT *((volatile unsigned int *)(MMR_BASE + 0xF460))

#define XMCFG  *((volatile unsigned char *)(MMR_BASE + 0xF000))
#define XM0CON *((volatile unsigned char *)(MMR_BASE + 0xF010))
#define XM1CON *((volatile unsigned char *)(MMR_BASE + 0xF014))
#define XM2CON *((volatile unsigned char *)(MMR_BASE + 0xF018))
#define XM3CON *((volatile unsigned char *)(MMR_BASE + 0xF01C))
#define XM0PAR *((volatile unsigned short *)(MMR_BASE + 0xF020))
#define XM1PAR *((volatile unsigned short *)(MMR_BASE + 0xF024))
#define XM2PAR *((volatile unsigned short *)(MMR_BASE + 0xF028))
#define XM3PAR *((volatile unsigned short *)(MMR_BASE + 0xF02C))

#define T0LD *((volatile unsigned int *)(MMR_BASE + 0x0300))
#define T0CON *((volatile unsigned int *)(MMR_BASE + 0x0308))
#define T0CLR *((volatile unsigned int *)(MMR_BASE + 0x030C))

#define IRQEN *((volatile unsigned short *)(MMR_BASE + 0x0008))

void enable_EM0(){
  /* AhXb`EFCgFȂ
     [h/CgAT[gOEFCgF
     [h/CgANZXF4NbN */
  XM0PAR = 0x00000444;
  XM0CON = 0x3;	/* 16rbgoX */
}

void enable_EM1(){
  /* AhXb`EFCgFȂ
     [h/CgAT[gOEFCgF
     [h/CgANZXF4NbN */
  XM1PAR = 0x00000444;
  XM1CON = 0x1;	/* 8rbgoX */
}

void enable_EM2(){
  /* AhXb`EFCgFȂ
     [h/CgAT[gOEFCgF
     [h/CgANZXF1NbN */
  XM2PAR = 0x00000411;
  XM2CON = 0x3;	/* 16rbgoX */
}

void enable_EM3(){
  /* AhXb`EFCgFȂ
     [h/CgAT[gOEFCgF
     [h/CgANZXF1NbN */
  XM3PAR = 0x00000411;
  XM3CON = 0x3;	/* 16rbgoX */
}

void enable_XMCFG(){
  /* AhXoX/f[^oXI */
  GP0CON = (GP0CON & 0x0FFFF00F) | 0x10000220;
  GP2CON = (GP2CON & 0x0000000F) | 0x22222220;
  GP3CON = 0x22222222;
  GP4CON = 0x22222222;
  XMCFG = 1;
}


#define ITERATION1 1000000
#define ITERATION2 1000000

void software_exception_func(){
  GP4DAT = 0xFF7F0000; // _
}

void prefetch_abort_func(){
  GP4DAT = 0xFFFF0000; // 
}

void FIQ_func(){

}

#define TIMER_INIT_VAL 0x4FA6
//0x27d3ɂ0.5bŏA0.5bœ_
//0x4FA6ɂ1bŏA1bœ_

void IRQ_func(){
  int i, loop;
  
  for(loop=0;loop<5;loop++){
    GP4DAT = 0xFF7F0000; // _
    for(i=0;i<ITERATION1/8;i++) {}
    GP4DAT = 0xFFFF0000; // 
    for(i=0;i<ITERATION1/8;i++) {}
  }
  // Timer0IRQNA
  T0CLR = 1; // ̒lł悢珑
  // ^C}[̏lݒ
  T0LD = TIMER_INIT_VAL*2; 
}

int main(){
  int i, loop;

  // GP4CONWX^GPIOP4.7GPIOƂĐݒ
  GP4CON = 0x00000000;
  
  // ^C}[̏lݒ
  T0LD = TIMER_INIT_VAL; 
  // Core clock1/16ɐݒ肵ATimer0X^[g
  T0CON = (1<<7) | (1 << 3);

#ifdef IRQ_TEST
  // Timer0IRQLɂ
  IRQEN |= (1<<2);
  while(1){}
#endif

#ifdef SWI_TEST
  for(loop=0;loop<10;loop++){
    asm volatile ("SWI 0x10"); // _
    for(i=0;i<ITERATION1;i++) {}
    GP4DAT = 0xFFFF0000; // 
    for(i=0;i<ITERATION2;i++) {}
  }
#endif

  return 0;
}
