/* Cortex-M3GDB stub @ˑ֐Q*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

#include "STM32_AddressDefs.h"

#define USARTx_SR USART1_SR
#define USARTx_DR USART1_DR


#define __EFI_ACR_Val 0x00000012
#define __RCC_CR_VAL  0x01000081
#define __RCC_CFGR_VAL 0x00288402
#define __NVIC_VTOR_VAL 0x00000000
#define __SYSTICK_CTRL_VAL 0x00000002
#define __SYSTICK_PERIOD 0x0000000A
#define CFGR_HPRE_MASK 0x000000F0 // Mask for AHB prescaler
#define __HCLKPRESC  0x00000000
#define __SYSTICKCLK (__HCLK>>3)
#define __HSI 8000000UL
#define CFGR_PLLMULL_MASK 0x003C0000 // Mask for PLL multiplier
#define __PLLMULL (((__RCC_CFGR_VAL & CFGR_PLLMULL_MASK) >> 18) + 2)
#define __SYSCLK  ((__HSI >> 1) * __PLLMULL)  // SYSCLK = HSI/2 * pllmul
#define __HCLK        (__SYSCLK)
#define CFGR_PRE2_MASK 0x00003800 // Mask for APB2 prescaler 
#define __PCLK2       (__HCLK)


#define __USART1_BAUDRATE         115200 //  4
#define __USART1_DATABITS         0x00000000
#define __USART1_STOPBITS         0x00000000
#define __USART1_PARITY           0x00000000
#define __USART1_FLOWCTRL         0x00000000

#define __DIV(__PCLK, __BAUD)       ((__PCLK*25)/(4*__BAUD))
#define __DIVMANT(__PCLK, __BAUD)   (__DIV(__PCLK, __BAUD)/100)
#define __DIVFRAQ(__PCLK, __BAUD)   (((__DIV(__PCLK, __BAUD) - (__DIVMANT(__PCLK, __BAUD) * 100)) * 16 + 50) / 100)
#define __USART_BRR(__PCLK, __BAUD) ((__DIVMANT(__PCLK, __BAUD) << 4)|(__DIVFRAQ(__PCLK, __BAUD) & 0x0F))

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case EXCEPTION_ILL_INSN:
      sigval = TARGET_SIGNAL_ILL;
      break;
    case EXCEPTION_PREFETCH_ABORT:
    case EXCEPTION_DATA_ABORT:
      sigval = TARGET_SIGNAL_BUS;
      break;
    case EXCEPTION_SOFTWARE:
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case EXCEPTION_IRQ:
    case EXCEPTION_FIQ:
      sigval = TARGET_SIGNAL_INT;
      break;
    case TERM_EXCEPTION:
      sigval = TARGET_SIGNAL_TERM;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// UART̎Mf[^ۂɂ
void clear_uart(){

}

/* M荞݋ */
void enable_int(){
  // UARTIRQLɂ
  USART1_CR1 |= (0x1<<5);

}

/* M荞݋֎~ */
void disable_int(){
  // UARTIRQ𖳌ɂ
  USART1_CR1 &= ~(0x1<<5);
}

#define __IWDG_PR             (2)
#define __IWDGCLOCK  (32000UL/16)
#define __IWGDCLK  (32000UL/(0x04<<__IWDG_PR))
#define __IWDG_RLR (2000000*__IWGDCLK/1000000UL-1)

void gdb_stub_kill_command(){
  // EHb`hbN^C}[ŃtZbg
  IWDG_KR  = 0x5555;
  IWDG_PR  = __IWDG_PR;
  IWDG_RLR = __IWDG_RLR;
  IWDG_KR  = 0xAAAA;
  IWDG_KR  = 0xCCCC;
  while(1);
}

// GDBgVA|[g܂B
void init_serial (){
  // GPIO Port A
  RCC_APB2ENR |= 0x00000004; // enable clock for GPIOA
  GPIOA_CRL = 0x00000000; // set Port configuration register low
  GPIOA_CRH = 0x00000000; // set Port configuration register high

  // USART Configuration
  // USART1 used
  AFIO_MAPR   &= ~(1 << 2); // clear USART1 remap
  // USART1 no remap
  RCC_APB2ENR |= 0x00000004; // enable clock for GPIOA
  GPIOA_CRH &= ~(0xFFUL  << 4); // Clear PA9, PA10
  GPIOA_CRH |=  (0x0BUL  << 4); // USART1 Tx (PA9)  alternate output push-pull
  GPIOA_CRH |=  (0x04UL  << 8); // USART1 Rx (PA10) input floating

  RCC_APB2ENR |= 0x00004000; // enable clock for USART1
  
  USART1_BRR = __USART_BRR(__PCLK2, __USART1_BAUDRATE); // set baudrate
  USART1_CR1 = __USART1_DATABITS; // set Data bits
  USART1_CR2 = __USART1_STOPBITS; // set Stop bits
  USART1_CR1 |= __USART1_PARITY; // set Parity
  USART1_CR3 = __USART1_FLOWCTRL; // Set Flow Control
  
  USART1_CR1 |= (0x00000004 | 0x00000008); // RX, TX enable

  // USART interrupts used
  USART1_CR1 &= ~(0x1<<5);
  USART1_CR2 |= 0x0;
  USART1_CR3 |= 0x0;
  //NVIC_Enable[1] |= (1 << (0x25 & 0x1F)); // enable interrupt
  *((volatile unsigned int *)0xE000E104) |= (1 << 5); // enable interrupt

  USART1_CR1 |= 0x00002000; // USART enable
}

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  volatile int c;
  while (!(USARTx_SR & 0x0020));
  c = ((int)(USARTx_DR & 0x1FF));
  return (char )c;
}

// 1M֐B
void putDebugChar (char ch){
  while (!(USARTx_SR & 0x0080));
  USARTx_DR = ((unsigned int)ch & 0x1FF);
}

void _illegalinst_func(void){
  gdb_handle_exception(EXCEPTION_ILL_INSN);
}

void _int_func(void){
  gdb_handle_exception(EXCEPTION_IRQ);
}

void _bus_func(void){
  gdb_handle_exception(EXCEPTION_DATA_ABORT);
}

void cpu_init_at_main(){
  // EFI Configuration
  FLASH_ACR = __EFI_ACR_Val; // set access control register 
  
  // Clock Configuration
  RCC_CFGR = __RCC_CFGR_VAL; // set clock configuration register
  RCC_CR   = __RCC_CR_VAL; // set clock control register
  
  while ((RCC_CR & 0x00000002) == 0){} // Wait for HSIRDY = 1 (HSI is ready)
  while ((RCC_CR & 0x02000000) == 0){} // Wait for PLLRDY = 1 (PLL is ready)
  
  /* Wait till SYSCLK is stabilized (depending on selected clock) */
  while ((RCC_CFGR & 0xC) != ((__RCC_CFGR_VAL<<2) & 0xC));

  // NVIC Configuration
  SCB_ExceptionTableOffset = (__NVIC_VTOR_VAL & 0x1FFFFF80); // set register
}



// GCC version4.3ȍ~łmemcpylibgcc.aɂȂ
void* memcpy(void *OUT, const void *IN, int N){
  int i;

  for(i=0;i<N;i++)
    *((unsigned char *)OUT + i) = *((unsigned char *)IN + i);

  return OUT;
}

