/* MicroBlazeGDB stub @ˑ֐Q*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

//#define MB_UART
//#define BLANCA_UART

#ifdef BLANCA_UART
#define COM1
//#define COM2
#endif

#define BLANCA_BaseAdr	0x80000000
/* CPUɂ킹ăx[XAhXύX邱 */

/* A/VvZbT䃌WX^` */
#define AVP_SignatureAdr *((volatile unsigned int *)(BLANCA_BaseAdr+0))
#define AVP_IntStatus *((volatile unsigned int *)(BLANCA_BaseAdr+0x10))
#define AVP_IntEnable *((volatile unsigned int *)(BLANCA_BaseAdr+0x14))

/* COM|[g䃌WX^ */
#ifdef COM1
#define	COM_ChipSelect	24
#define	COM_BaseAdr	0xBE000000
#else
#define	COM_ChipSelect	4
#define	COM_BaseAdr	0x88000000
#endif
#define	COM_Revison	*((volatile unsigned int *)(COM_BaseAdr+4))
#define	COM_IntStatus	*((volatile unsigned int *)(COM_BaseAdr+0x10))
#define	COM_IntEnable	*((volatile unsigned int *)(COM_BaseAdr+0x14))
#define	COM_CtrlReg	*((volatile unsigned int *)(COM_BaseAdr+0x20))
#define	COM_RecvCtrl	*((volatile unsigned int *)(COM_BaseAdr+0x24))
#define	COM_SendCtrl	*((volatile unsigned int *)(COM_BaseAdr+0x28))
#define	COM_BpsCtrl	*((volatile unsigned int *)(COM_BaseAdr+0x2C))

struct breakpoint_list breakpoint_addr_list[MAX_BREAK];

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case HARDWARE_EXCEPTION_ILL_INSN:
      sigval = TARGET_SIGNAL_ILL;
      break;
    case HARDWARE_EXCEPTION_BUS_ERR:
      sigval = TARGET_SIGNAL_BUS;
      break;
    case BREAK_EXCEPTION_SOFT:
    case BREAK_EXCEPTION_HARD: // including NMI
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case INTERRUPT_EXCEPTION:
      sigval = TARGET_SIGNAL_INT;
      break;
    case USER_VECTOR_EXCEPTION:
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case TERM_EXCEPTION:
      sigval = 15;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

void enable_int(){
  volatile int msr_val;
#ifdef BLANCA_UART
  GET_MSR(msr_val);
  msr_val |= (1<<1);
  SET_MSR(msr_val);
  //  COM_IntEnable=0x3;		/* M荞݋ */
  COM_IntEnable=0x1;		/* M荞݋ */
#endif
}

void disable_int(){
  volatile int msr_val;

#ifdef BLANCA_UART
  COM_IntEnable=0x0;		/* M荞݋֎~ */
  GET_MSR(msr_val);
  msr_val &= ~(1<<1);
  SET_MSR(msr_val);
#endif
}

void clear_uart(){
#ifdef BLANCA_UART
  int stat,l;
  char data;

  stat=COM_IntStatus;	/* 荞݃Xe[^X擾 */

  if (stat&1) {	/* M荞 */
    data = (char)COM_RecvCtrl & 0xFF;
  }
  if (stat&2) {	/* M荞 */
		/* e */
  }
  COM_IntStatus=stat;	/* 荞݃NA */
  
#endif
}

void gdb_stub_kill_command(){
  int j;
  disable_int();
  COM_CtrlReg=0x80000000;	/* COMZbg */
  asm volatile ("bra r0");
  asm volatile ("nop");
}

/* MicroBlaze ope_uartlitepWX^` */
#define MB_UartBaseAdr	0x40600000	/* x[XAhX */

#define MB_UartRecv *((volatile unsigned int *)(MB_UartBaseAdr+0))
#define MB_UartSend *((volatile unsigned int *)(MB_UartBaseAdr+4))
#define MB_UartStat *((volatile unsigned int *)(MB_UartBaseAdr+8))
#define MB_UartCtrl *((volatile unsigned int *)(MB_UartBaseAdr+12))

// GDBgVA|[g܂B
void init_serial (){
#ifdef BLANCA_UART
  COM_CtrlReg=0x80000000;	/* COMZbg */
  COM_BpsCtrl  =1;			/* 115200bpsݒ */
  //  *COM_BpsCtrl  =12;			/* 9600bpsݒ */
  COM_IntStatus=0x3;		/* 荞݃Xe[^XNA */
  COM_IntEnable=0x0;		/* M荞ݕs */
  COM_CtrlReg=0x40000008;	/* COMZbg/n[hEFAt[/RTSCl[u */
  COM_IntEnable=0x0;		/* M荞݋֎~ */
  AVP_IntEnable=(1<<COM_ChipSelect);
#endif
#ifdef MB_UART
  /* MicroBlazeł͂Ƃɏe */
  
  // MFIFOZbg
  (MB_UartCtrl) = 0x3;
#endif

}

/* R\[̓obt@`FbN */
int CPU_UartRecvCheck(void)
{
  unsigned int status;
  status=MB_UartStat;	/* UARTXe[^X */
  if ( status & 1 ) {	/* f[^M */
    return 1;	/* Mf[^ */
  } else {
    return 0;	/* Mf[^Ȃ */
  }
}

/* R\[̓obt@`FbN */
int BLANCA_UartRecvCheck(void)
{
  unsigned int status;
  status=COM_CtrlReg;	/* UARTXe[^X擾 */
  if (status&1) {	/* M */
    return 1;	/* Mf[^ */
  } else {
    return 0;	/* Mf[^Ȃ */
  }
}

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  char data;

#ifdef BLANCA_UART
  int stat,l;
  
  do{
    stat=COM_IntStatus;	/* 荞݃Xe[^X擾 */
  }while((stat&1) ==0);

  if (stat&1) {	/* M荞 */
    data = (char)COM_RecvCtrl & 0xFF;
  }
  if (stat&2) {	/* M荞 */
		/* e */
  }
  COM_IntStatus=stat;	/* 荞݃NA */
  
#endif
#ifdef MB_UART
  while(1)
    {
      if (CPU_UartRecvCheck()) {	/* f[^M */
	data=(char)MB_UartRecv;	/* Mf[^ */
	break;
      }
    }
#endif
  return data;

}

// 1M֐B
void putDebugChar (char ch){
  unsigned int status;
  int i;


#ifdef BLANCA_UART
  while(1) {
    status=COM_SendCtrl;	/* M䃌WX^Xe[^X擾 */
    if ((status&0x100)==0) {	/* Mobt@󂢂Ă邩 */
      COM_SendCtrl=(unsigned int)ch;	/* Mf[^ */
      break;
    }
  }
#endif

#ifdef MB_UART
  while(1)
    {
      status=MB_UartStat;	/* UARTXe[^X */
      if ( !(status & 8) ) {	/* Mobt@󂢂Ă邩 */
	/* 1oCg(data)M */
	MB_UartSend=(unsigned int)ch;	/* Mf[^ */
	break;
      }
    }
#endif
}

void int_handler(){
  int stat,l;
  
  stat=COM_IntStatus;	/* 荞݃Xe[^X擾 */
  if (stat&1) {	/* M荞 */
    putDebugChar((char)COM_RecvCtrl & 0xFF);
  }
  if (stat&2) {	/* M荞 */
		/* e */
  }
  COM_IntStatus=stat;	/* 荞݃NA */
}


void _illegalinst_func(void){
  gdb_handle_exception(HARDWARE_EXCEPTION_ILL_INSN);
}

void _int_func(void){
  gdb_handle_exception(INTERRUPT_EXCEPTION);
}

#define  BLANCA_LED  *((volatile unsigned int *)0x8a000020)

void cpu_init_at_main(){
  volatile int msr_val;
  volatile int i;

  for(i=0;i<MAX_BREAK;i++)
    breakpoint_addr_list[i].used = 0;

  BLANCA_LED = 0;

  // Hardware ExceptionCl[u
  msr_val = (1<<8);
  SET_MSR(msr_val);
}





