/* MIPS GDB stub @ˑ֐Q*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case HARDWARE_EXCEPTION_ILL_INSN:
      sigval = TARGET_SIGNAL_ILL;
      break;
    case HARDWARE_EXCEPTION_BUS_ERR:
      sigval = TARGET_SIGNAL_BUS;
      break;
    case BREAK_EXCEPTION_SOFT:
    case BREAK_EXCEPTION_HARD: // including NMI
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case INTERRUPT_EXCEPTION:
      sigval = TARGET_SIGNAL_INT;
      break;
    case TERM_EXCEPTION:
      sigval = TARGET_SIGNAL_TERM;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// UART̎Mf[^ۂɂ
void clear_uart(){

}

/* Vr4131VARg[pWX^` */
#define SIU_BaseAdr	0xAF000800	/* SIUx[XAhX */
//#define SIU_BaseAdr		0xAF000820	/* DSIUx[XAhX */

#define SIU_RBR		*((volatile unsigned char *)(SIU_BaseAdr+0))
#define SIU_THR		*((volatile unsigned char *)(SIU_BaseAdr+0))
#define SIU_DLL		*((volatile unsigned char *)(SIU_BaseAdr+0))
#define SIU_IER		*((volatile unsigned char *)(SIU_BaseAdr+1))
#define SIU_DLM		*((volatile unsigned char *)(SIU_BaseAdr+1))
#define SIU_IIR		*((volatile unsigned char *)(SIU_BaseAdr+2))
#define SIU_FIFO	*((volatile unsigned char *)(SIU_BaseAdr+2))
#define SIU_LCR		*((volatile unsigned char *)(SIU_BaseAdr+3))
#define SIU_MCR		*((volatile unsigned char *)(SIU_BaseAdr+4))
#define SIU_LSR		*((volatile unsigned char *)(SIU_BaseAdr+5))
#define SIU_MSR		*((volatile unsigned char *)(SIU_BaseAdr+6))

#define SIU_RESET	*((volatile unsigned char *)(0xAF000809))

#define SYSINT1REG *((volatile unsigned short *)0xAF00008C)

/* M荞݋ */
void enable_int(){
  SIU_IER |= 0x1;
}

/* M荞݋֎~ */
void disable_int(){
  SIU_IER &= ~0xF1;
}


// PMC3
#define PMC3 *((volatile unsigned short *)0xFFFFF446)
#define PFC3 *((volatile unsigned short *)0xFFFFF466)

// GDBgVA|[g܂B
void init_serial (){
}

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  unsigned char data;

  while(1)
    {
      if (SIU_LSR & 1) {	/* f[^M */
	data=(unsigned char)SIU_RBR;	/* Mf[^ */
	break;
      }
    }
  return data;
}

// 1M֐B
void putDebugChar (char ch){
  unsigned char status;
  while(1)
    {
      status=SIU_LSR;	/* CEXe[^X擾 */
      if (status & 0x20) {	/* Mobt@󂢂Ă邩 */
	/* 1oCg(ch)M */
	SIU_THR=ch;	/* Mf[^ */
	break;
      }
    }
}

void cpu_init_at_main(){
  asm(".set noat");
  asm(".set noreorder");
  asm("li $1,0x0401");
  asm("mtc0 $1,$12"); 
  asm(".set at");
  asm(".set reorder");

  SIU_LCR &= ~(1<<7);  
  SYSINT1REG |= (1<<9);
}

void _illegalinst_func(void){
  gdb_handle_exception(HARDWARE_EXCEPTION_ILL_INSN);
}

void _int_func(void){
  gdb_handle_exception(INTERRUPT_EXCEPTION);
}

void _break_func(void){
  gdb_handle_exception(BREAK_EXCEPTION_SOFT);
}

void gdb_stub_kill_command(){
  asm ("j main");
  asm ("nop");
}
