/* powerpc GDB stub @ˑ֐Q*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case HARDWARE_EXCEPTION_ILL_INSN:
      sigval = TARGET_SIGNAL_ILL;
      break;
    case HARDWARE_EXCEPTION_BUS_ERR:
      sigval = TARGET_SIGNAL_BUS;
      break;
    case BREAK_EXCEPTION_SOFT:
    case BREAK_EXCEPTION_HARD: // including NMI
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case INTERRUPT_EXCEPTION:
      sigval = TARGET_SIGNAL_INT;
      break;
    case TERM_EXCEPTION:
      sigval = TARGET_SIGNAL_TERM;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// UART̎Mf[^ۂɂ
void clear_uart(){

}

#define MBAR *((volatile unsigned int *)0xF0000000)

#define PSC_OFFSET 0x2000

#define PSC_BASE ((MBAR<<16) + PSC_OFFSET)

#define PSC_MR1 *((volatile unsigned char *)(PSC_BASE + 0x00))
#define PSC_MR2 *((volatile unsigned char *)(PSC_BASE + 0x00))
#define PSC_SR *((volatile unsigned short *)(PSC_BASE + 0x04))
#define PSC_CSR *((volatile unsigned short *)(PSC_BASE + 0x04))
#define PSC_CR *((volatile unsigned char *)(PSC_BASE + 0x08))
//#define PSC_RB *((volatile unsigned int *)(PSC_BASE + 0x0C))
//#define PSC_TB *((volatile unsigned int *)(PSC_BASE + 0x0C))
#define PSC_RB *((volatile unsigned char *)(PSC_BASE + 0x0C))
#define PSC_TB *((volatile unsigned char *)(PSC_BASE + 0x0C))
#define PSC_IPCR *((volatile unsigned char *)(PSC_BASE + 0x10))
#define PSC_ACR *((volatile unsigned char *)(PSC_BASE + 0x10))
#define PSC_ISR *((volatile unsigned short *)(PSC_BASE + 0x14))
#define PSC_IMR *((volatile unsigned short *)(PSC_BASE + 0x14))
#define PSC_CTUR *((volatile unsigned char *)(PSC_BASE + 0x18))
#define PSC_CTLR *((volatile unsigned char *)(PSC_BASE + 0x1C))
#define PSC_CCR *((volatile unsigned int *)(PSC_BASE + 0x20))
#define PSC_AC97Slots *((volatile unsigned int *)(PSC_BASE + 0x24))
#define PSC_AC97CMD *((volatile unsigned int *)(PSC_BASE + 0x28))
#define PSC_AC97Data *((volatile unsigned int *)(PSC_BASE + 0x2C))
#define PSC_IVR *((volatile unsigned char *)(PSC_BASE + 0x30))
#define PSC_IP *((volatile unsigned char *)(PSC_BASE + 0x34))
#define PSC_OP1 *((volatile unsigned char *)(PSC_BASE + 0x38))
#define PSC_OP0 *((volatile unsigned char *)(PSC_BASE + 0x3C))
#define PSC_SICR *((volatile unsigned int *)(PSC_BASE + 0x40))
#define PSC_IRCR1 *((volatile unsigned char *)(PSC_BASE + 0x44))
#define PSC_IRCR2 *((volatile unsigned char *)(PSC_BASE + 0x48))
#define PSC_IRSDR *((volatile unsigned char *)(PSC_BASE + 0x4C))
#define PSC_IRMDR *((volatile unsigned char *)(PSC_BASE + 0x50))
#define PSC_IRFDR *((volatile unsigned char *)(PSC_BASE + 0x54))
#define PSC_RFNUM *((volatile unsigned short *)(PSC_BASE + 0x58))
#define PSC_TFNUM *((volatile unsigned short *)(PSC_BASE + 0x5C))
#define PSC_RFDATA *((volatile unsigned int *)(PSC_BASE + 0x60))
#define PSC_RFSTAT *((volatile unsigned short *)(PSC_BASE + 0x64))
#define PSC_RFCNTL *((volatile unsigned char *)(PSC_BASE + 0x68))
#define PSC_RFALARM *((volatile unsigned short *)(PSC_BASE + 0x6E))
#define PSC_RFRPTR *((volatile unsigned short *)(PSC_BASE + 0x72))
#define PSC_RFWPTR *((volatile unsigned short *)(PSC_BASE + 0x76))
#define PSC_RFLRFPTR *((volatile unsigned short *)(PSC_BASE + 0x7A))
#define PSC_RFLWFPTR *((volatile unsigned short *)(PSC_BASE + 0x7C))
#define PSC_TFDATA *((volatile unsigned int *)(PSC_BASE + 0x80))
#define PSC_TFSTAT *((volatile unsigned short *)(PSC_BASE + 0x84))
#define PSC_TFCNTL *((volatile unsigned char *)(PSC_BASE + 0x88))
#define PSC_TFALARM *((volatile unsigned short *)(PSC_BASE + 0x8E))
#define PSC_TFRPTR *((volatile unsigned short *)(PSC_BASE + 0x92))
#define PSC_TFWPTR *((volatile unsigned short *)(PSC_BASE + 0x96))
#define PSC_TFLRFPTR *((volatile unsigned short *)(PSC_BASE + 0x9A))
#define PSC_TFLWFPTR *((volatile unsigned short *)(PSC_BASE + 0x9C))

#define ICTL_PIMR *((volatile unsigned int *)(MBAR + 0x500))
#define ICTL_HILOSEL1 *((volatile unsigned int *)(MBAR + 0x504))
#define ICTL_INTEMU *((volatile unsigned int *)(MBAR + 0x544))

/* M荞݋ */
void enable_int(){
}

/* M荞݋֎~ */
void disable_int(){
}


// GDBgVA|[g܂B
void init_serial (){
}

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  unsigned char data;

  while((PSC_SR & (1<<8)) == 0){}
  data = PSC_RB;
  return data;
}

// 1M֐B
void putDebugChar (char ch){
  //while((PSC_SR & (1<<6)) != 0){}
  PSC_TB = ch;
}

void cpu_init_at_main(){
}

void _illegalinst_func(void){
  gdb_handle_exception(HARDWARE_EXCEPTION_ILL_INSN);
}

void _int_func(void){
  gdb_handle_exception(INTERRUPT_EXCEPTION);
}

void _break_func(void){
  gdb_handle_exception(BREAK_EXCEPTION_SOFT);
}

void gdb_stub_kill_command(){
  asm ("b main");
}
