/**** SH4AGDBX^u @ˑ֐Q ****/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

#define FRQCR *((volatile unsigned int *)0xFFC80030)
#define SCSMR0 *((volatile unsigned short *)0xFFE00000)
#define SCBRR0 *((volatile unsigned char *)0xFFE00004)
#define SCSCR0 *((volatile unsigned short *)0xFFE00008)
#define SCFTDR0 *((volatile unsigned char *)0xFFE0000C)
#define SCFSR0 *((volatile unsigned short *)0xFFE00010)
#define SCFRDR0 *((volatile unsigned char *)0xFFE00014)
#define SCFCR0 *((volatile unsigned short *)0xFFE00018)
#define SCTFDR0 *((volatile unsigned short *)0xFFE0001C)
#define SCRFDR0 *((volatile unsigned short *)0xFFE00020)
#define SCSPTR0 *((volatile unsigned short *)0xFFE00024)
#define SCLSR0 *((volatile unsigned short *)0xFFE00028)
#define SCRER0 *((volatile unsigned short *)0xFFE0002C)

#define INT2PRI2 *((volatile unsigned int *)0xFFD40008)
#define INT2MSKR *((volatile unsigned int *)0xFFD40038)
#define INT2MSKCR *((volatile unsigned int *)0xFFD4003C)


void enable_int(){
  // M荞݂Cl[u
  SCSCR0 |= (1<<6) | (1<<3);
  // D揇ʂ31ɐݒ
  INT2PRI2 |= (31 << 24);
  // }XN
  INT2MSKCR = (1<<3);
}

void disable_int(){
  // M荞݂fBXG[u
  SCSCR0 &= ~((1<<6) | (1<<3));
  // }XNZbg
  INT2MSKR |= (1<<3);
}

#define CBR0 *((volatile unsigned int *)0xFF200000)
#define CRR0 *((volatile unsigned int *)0xFF200004)
#define CAR0 *((volatile unsigned int *)0xFF200008)
#define CAMR0 *((volatile unsigned int *)0xFF20000C)
#define CBR1 *((volatile unsigned int *)0xFF200020)
#define CRR1 *((volatile unsigned int *)0xFF200024)
#define CAR1 *((volatile unsigned int *)0xFF200028)
#define CAMR1 *((volatile unsigned int *)0xFF20002C)
#define CDR1 *((volatile unsigned int *)0xFF200030)
#define CDMR1 *((volatile unsigned int *)0xFF200034)
#define CETR1 *((volatile unsigned int *)0xFF200038)
#define CCMFR *((volatile unsigned int *)0xFF200600)
#define CBCR *((volatile unsigned int *)0xFF200620)
#define PHCR *((volatile unsigned short *)0xFFEA000E)

// [Uu[NRg[̃u[N|Cg폜֐
// addrɈvUBC`l𖳌B
void UBC_clr(unsigned int addr){
  if(CAR0 == (addr & ~0x1))
    CBR0 &= ~1;
  if(CAR1 == (addr & ~0x1))
    CBR1 &= ~1;
}

// [Uu[NRg[Ƀu[N|Cgݒ肷֐
// 1ԂBs0ԂB
// UBC`l̂A󂢂ĂقɃZbgB
int UBC_set(unsigned int addr){
  if((CBR0 & 0x1) == 0){

    // AhXݒ
    CAR0 = addr & ~0x1;
    CAMR0 = 0;

    // }b`ݒB
    // ߎsu[NAu[Nv
    CRR0 |= (1<<1) | 1;

    // `lݒ肷B
    // ߃tFb`TCN
    // ǂݏoTCN
    // Cl[u
    CBR0 = (1<<4) | (1 << 1) | 1;
  }
  else if((CBR1 & 0x1) == 0){
    // AhXݒ
    CAR1 = addr & ~0x1;
    CAMR1 = 0;

    CETR1 = 0;

    // }b`ݒB
    // ߎsu[NAu[Nv
    CRR1 |= (1<<1) | 1;

    // `lݒ肷B
    // ߃tFb`TCN
    // ǂݏoTCN
    // Cl[u
    CBR1 = (1<<4) | (1 << 1) | 1;    
  }
  else{
    return 0;
  }

  return 1;
}

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;
  
  switch (exceptionVector)
    {
    case INT_EXCEPTION:
      sigval = 2;
      break;
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case TERM_EXCEPTION:
      sigval = 15;
      break;
    case INVALID_INSN_VEC:
      sigval = 4;
      break;
    case INVALID_SLOT_VEC:
      sigval = 4;
      break;
    case CPU_BUS_ERROR_VEC:
      sigval = 10;
      break;
    case DMA_BUS_ERROR_VEC:
      sigval = 10;
      break;
    case NMI_VEC:
      sigval = 2;
      break;
    case TRAP_VEC:
    case USER_VEC:
      sigval = 5;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// GDBgVA|[g܂B
// baudrateɂ960019200w肷B
void init_serial (){

  // |[gH SCIFL
  PHCR = 0;

  SCSCR0 = 0x0;
  SCFCR0 = 0x6;
  SCSMR0 = 0x0;
  
  if((FRQCR & 0xF) == 5){ // x1.5
    switch(DEBUG_BAUDRATE){
    case 9600:// 9600bps
      SCBRR0 = 160;
      break;
    case 19200: // 19200bps
      SCBRR0 = 79;
      break;
    case 115200: // 115200 bps
      SCBRR0 = 12;
      break;
    }
  }
  else{ // x1
    switch(DEBUG_BAUDRATE){
    case 9600: // 9600bps
      SCBRR0 = 106;
      break;
    case 19200: // 19200bps
      SCBRR0 = 53;
      break;
    case 115200: // 115200 bps
      SCBRR0 = 8;
      break;
    }
  }

  // 1bit wait
  volatile int i;
  for(i=0;i<1000;i++){}

  SCFCR0 = 0x0;
  SCSCR0 = (1<<5) | (1<<4);
  SCSPTR0 = 0x80;
}

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  char recv_char;

  while((SCFSR0 & 0x3)  == 0) {}
  recv_char = SCFRDR0;
  SCFSR0 &= ~0x3;

  return recv_char;
}

// 1M֐B
void putDebugChar (char ch){
  while((SCFSR0 & (1<<5)) == 0) {}
  SCFTDR0 = ch;
  SCFSR0 |= (1<<5);
  while(SCTFDR0 != 0) {}
}

void _illegalinst_func(void){
  gdb_handle_exception(INVALID_INSN_VEC);
}

void _rxint_func(void){
  gdb_handle_exception(INT_EXCEPTION);
}

void _trap_func(void){
  gdb_handle_exception(TRAP_VEC);
}

void gdb_stub_kill_command(){
    asm volatile("stc vbr, r1");
    asm volatile("jmp @r1");
    asm volatile("nop");
}

#define BLANCA_LED *((volatile unsigned int *)0xA4C00020)
void cpu_init_at_main(){
  // [Uu[NfobOT|[g@\fBXG[u
  CBCR = 0;

  BLANCA_LED = 0;
}





