/* V850Et^GDB stub @ˑ֐Q*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case HARDWARE_EXCEPTION_ILL_INSN:
      sigval = TARGET_SIGNAL_ILL;
      break;
    case HARDWARE_EXCEPTION_BUS_ERR:
      sigval = TARGET_SIGNAL_BUS;
      break;
    case BREAK_EXCEPTION_SOFT:
    case BREAK_EXCEPTION_HARD: // including NMI
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case INTERRUPT_EXCEPTION:
      sigval = TARGET_SIGNAL_INT;
      break;
    case USER_VECTOR_EXCEPTION:
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case TERM_EXCEPTION:
      sigval = TARGET_SIGNAL_TERM;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// UART̎Mf[^ۂɂ
void clear_uart(){

}

// UART0֘A䃌WX^
#define UA0CTL0 *((volatile unsigned char *)0xFFFFFA00)
#define UA0CTL1 *((volatile unsigned char *)0xFFFFFA01)
#define UA0CTL2 *((volatile unsigned char *)0xFFFFFA02)
#define UA0TX *((volatile unsigned char *)0xFFFFFA07)
#define UA0RX *((volatile unsigned char *)0xFFFFFA06)
#define UA0RIC *((volatile unsigned char *)0xFFFFF162)
#define UA0TIC *((volatile unsigned char *)0xFFFFF164)

// EHb`hbO^C}[2䃌WX^
#define WDTM2 *((volatile unsigned char *)0xFFFFF6D0)
#define WDTE *((volatile unsigned char *)0xFFFFF6D1)


/* M荞݋ */
void enable_int(){
  UA0RIC = 0x00;
  asm ("ei");
}

/* M荞݋֎~ */
void disable_int(){
  asm ("di");
  UA0RIC = (1<<6) | (7<<0);
}


// PMC3
#define PMC3 *((volatile unsigned short *)0xFFFFF446)
#define PFC3 *((volatile unsigned short *)0xFFFFF466)

// GDBgVA|[g܂B
void init_serial (){
  // 9600 bps
  //  UA0CTL1 = 0x03;
  //  UA0CTL2 = 0x82;

  // 19200 bps
  //  UA0CTL1 = 0x02;
  //  UA0CTL2 = 0x82;

  // 38400 bps
  UA0CTL1 = 0x01;
  UA0CTL2 = 0x82;

  // peBȂAf[^8rbgAXgbvrbg1rbg
  //UA0CTL0 = (1<<7) | (0<<6) | (0<<5) | (1<<4) | (2<<3) | (1<<1) | (0<<0);
  UA0CTL0 = 0x92;

  // |[gUARTɐݒ
  PMC3 |= 0x0003;
  PFC3 &= ~(0x0003);

  // M
  UA0CTL0 |= (1<<6) | (1<<5);

  
}

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  char data;

  while((UA0RIC & (1<<7)) == 0){}
  UA0RIC &= ~(1<<7);
  data = UA0RX;
   
  return data;

}

// 1M֐B
void putDebugChar (char ch){
  
  UA0TX = (unsigned char)ch;
  while((UA0TIC & (1<<7)) == 0){}
  UA0TIC &= ~(1<<7);
}

// LOCKRWX^
#define LOCKR *((volatile unsigned char *)0xFFFFF824)
// PLLCTLWX^
#define PLLCTL *((volatile unsigned char *)0xFFFFF82C)

#define PRCMD *((unsigned char *)0xFFFFF1FC)
#define PCC *((unsigned char *)0xFFFFF828)

void configure_clock(){
  // NbNX[łS{
  PRCMD = 0;
  PCC = 0;
  while(LOCKR);
  PLLCTL |= (1<<1);
}

// WDTM2WX^
#define WDTM2 *((volatile unsigned char *)0xFFFFF6D0)
// VSWCWX^
#define VSWC *((volatile unsigned char *)0xFFFFF06E)

// PMCTWX^
#define PMCT *((volatile unsigned char *)0xFFFFF02A)
// PCTWX^
#define PCT *((volatile unsigned char *)0xFFFFF00A)
// PMCCTWX^
#define PMCCT *((volatile unsigned char *)0xFFFFF04A)

void cpu_init_at_main(){
  // NbNݒ
  configure_clock();
}

void _illegalinst_func(void){
  gdb_handle_exception(HARDWARE_EXCEPTION_ILL_INSN);
}

extern unsigned int registers[];

void _trap_func(void){
  volatile unsigned int tmp;

  //  asm volatile ("stsr dir,%0" : "=r" (tmp));
  //  registers[R0] = tmp;
  //if(tmp & 0x1)
  gdb_handle_exception(BREAK_EXCEPTION_SOFT);
  //else
  //gdb_handle_exception(HARDWARE_EXCEPTION_ILL_INSN);
}

void _int_func(void){
  gdb_handle_exception(INTERRUPT_EXCEPTION);
}

// PCTWX^
#define PCT *((volatile unsigned char *)0xFFFFF00A)

void gdb_stub_kill_command(){
  // EHb`hbO^C}[ŃZbgB
  //  WDTM2 = (1<<6) | 0x15; // 500msec
  //  WDTE = 0xac;

  asm volatile ("mov hilo(0x00000020), r1");
  asm volatile ("ldsr r1, psw");
  asm volatile ("jmp [r0]");
}
